> ## Documentation Index
> Fetch the complete documentation index at: https://docs.bubblemaps.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Token Top Holders

<Info>**Credit cost:** 1 per request.</Info>

Get the top holders of any given token.

<Warning>
  All tokens are supported by default, including NFT collections, but beware of
  errors: a `404` will be returned if no holders are found, and a `400` might be
  returned for some rare unsupported tokens.
</Warning>

You'll find the parameters and response schemas at the end of this page, but here's some additional context:

### Parameters

* The base response includes the top 80 holders of the token. This is the same as the iFrame integrations. You can change the number of holders with the `limit` parameter.
* The `return_metadata` query parameter includes the labels and metadata of the holders in the response.
* Data can be cached for performance, cache TTL depends on token age. Date of update can be found in the `X-Dt-Update` response header. If you need to force a refresh, you can use the `refresh=true` query param.
* **History mode**: to access the top holders of a token in a specific date in the past, use the `timestamp` parameter (unix timestamp)

| Option                 | Credits |
| ---------------------- | ------: |
| Base request           |       1 |
| `limit=250`            |     +10 |
| `limit=500`            |     +25 |
| `return_metadata=true` |     +25 |
| `refresh=true`         |     +25 |
| `timestamp=XXX`        |     +50 |

### Response

* All share values are in `[0, 1]` format, meaning `42%` will be returned as `0.42`.
* When `return_metadata=true`, the `is_paid_label` boolean indicates whether the label is a [community-submitted label](https://wiki.bubblemaps.io/bubblemaps-v2/submit-labels).


## OpenAPI

````yaml GET /v0/tokens/holders/{chain}/{token_address}
openapi: 3.1.0
info:
  title: Bubblemaps Data API
  version: 0.2.2
servers:
  - url: https://api.bubblemaps.io
security: []
paths:
  /v0/tokens/holders/{chain}/{token_address}:
    get:
      tags:
        - v0
      summary: Get Token Holders
      operationId: get_token_holders_v0_tokens_holders__chain___token_address__get
      parameters:
        - name: chain
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/ChainIdV0'
        - name: token_address
          in: path
          required: true
          schema:
            type: string
            title: Token Address
        - name: limit
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/HoldersLimit'
            default: 80
        - name: timestamp
          in: query
          required: false
          schema:
            anyOf:
              - type: integer
              - type: 'null'
            ge: 0
            title: The unix timestamp in seconds.
        - name: refresh
          in: query
          required: false
          schema:
            type: boolean
            title: If true, bypass cache and force a refresh to latest data.
            default: false
        - name: return_metadata
          in: query
          required: false
          schema:
            type: boolean
            title: If true, include address metadata in the response.
            default: false
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/TokenHolderV0'
                title: >-
                  Response Get Token Holders V0 Tokens Holders  Chain   Token
                  Address  Get
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyHeader: []
components:
  schemas:
    ChainIdV0:
      type: string
      enum:
        - eth
        - base
        - solana
        - tron
        - bsc
        - sonic
        - ton
        - avalanche
        - polygon
        - monad
        - hyperevm
        - arbitrum
        - robinhood
      title: ChainIdV0
    HoldersLimit:
      type: integer
      enum:
        - 80
        - 250
        - 500
      title: HoldersLimit
    TokenHolderV0:
      properties:
        address:
          type: string
          title: Address
        address_details:
          anyOf:
            - $ref: '#/components/schemas/AccountAddressDetails'
            - type: 'null'
        holder_data:
          $ref: '#/components/schemas/HolderData'
      type: object
      required:
        - address
        - holder_data
      title: TokenHolderV0
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    AccountAddressDetails:
      properties:
        label:
          anyOf:
            - type: string
            - type: 'null'
          title: Label
        degree:
          type: integer
          title: Degree
        is_supernode:
          type: boolean
          title: Is Supernode
        is_contract:
          type: boolean
          title: Is Contract
        is_cex:
          type: boolean
          title: Is Cex
        is_dex:
          type: boolean
          title: Is Dex
        is_paid_label:
          type: boolean
          title: Is Paid Label
          default: false
        entity_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Entity Id
        inward_relations:
          type: integer
          title: Inward Relations
        outward_relations:
          type: integer
          title: Outward Relations
        first_activity_date:
          anyOf:
            - type: string
              format: date-time
            - type: 'null'
          title: First Activity Date
      type: object
      required:
        - degree
        - is_supernode
        - is_contract
        - is_cex
        - is_dex
        - inward_relations
        - outward_relations
      title: AccountAddressDetails
    HolderData:
      properties:
        amount:
          type: number
          title: Amount
        rank:
          type: integer
          title: Rank
        share:
          type: number
          title: Share
      type: object
      required:
        - amount
        - rank
        - share
      title: HolderData
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyHeader:
      type: apiKey
      in: header
      name: X-ApiKey

````